{******************************************************************************}
{          This unit is part of the Delphifreeware component package.          }                                                                              
{                                                                              }
{ Filename           : DFWAbout.pas                                            }
{ Short description  :                                                         }
{ Author             : Carsten Butzek                                          }
{ E-Mail             : cabutzek@muenster.de                                    }
{ Internet           : http://www.delphifreeware.de                            }
{ Version            : 1.0                                                     }
{ Date last modified : 03/12/2000                                              }
{ Delphi versions    : 2,3,4,5                                                 }
{                                                                              }
{                                                                              }
{ Add. Copyright     :                                                         }
{                                                                              }
{ Description        :                                                         }
{                                                                              }
{ Usage              :                                                         }
{                                                                              }
{ Revision history   :                                                         }
{                                                                              }
{ This unit contains the following                                             }
{ Components       :                                                           }
{ Classes          : TDFWAboutForm                                             }
{ Types            :                                                           }
{ Constants        :                                                           }
{ Global variables :                                                           }
{ Global procedures: ShowDFWAboutAboutDialog                                   }
{ Global functions :                                                           }
{                                                                              }
{******************************************************************************}
{                                                                              }
{  DFW and Delphifreeware   2000, Carsten Butzek E-Mail: cabutzek@muenster.de }
{                                                                              }
{  Delphifreeware or DFW is a free Delphi component collection.                }
{  If you wrote a component which should be integrated into the DFW please     }
{  contact me.                                                                 }
{                                                                              }
{  Updates of the DFW package are available at the DFW homepage:               }
{  http://www.delphifreeware.de                                                }
{                                                                              }
{******************************************************************************}
{ License agreement                                                            }
{                                                                              }
{  This unit is freeware.                                                      }
{                                                                              }
{  Please do not release modified versions of this source code.                }
{  If you've made any changes that you think should have been there,           }
{  feel free to submit them to me at cabutzek@muenster.de                      }
{                                                                              }
{                                                                              }
{  This software is provided 'as-is', without any express or                   }
{  implied warranty. In no event will the author be held                       }
{  liable for any damages arising from the use of this                         }
{  software.                                                                   }
{  Permission is granted to anyone to use this software for                    }
{  any purpose, including commercial applications, and to                      }
{  alter it and redistribute it freely, subject to the                         }
{  following restrictions:                                                     }
{  1. The origin of this software must not be misrepresented,                  }
{     you must not claim that you wrote the original software.                 }
{     If you use this software in a product, an acknowledgment                 }
{     in the product documentation would be appreciated but is                 }
{     not required.                                                            }
{  2. Altered source versions must be plainly marked as such,                  }
{     and must not be misrepresented as being the original                     }
{     software.                                                                }
{  3. This notice may not be removed or altered from any                       }
{     source distribution.                                                     }
{  4. You must credit the DFW team in  your software including a               }
{     link to the DFW homepage at http://www.delphifreeware.de.                }
{                                                                              }
{ End of license agreement                                                     }
{                                                                              }
{******************************************************************************}

{$I DFW.INC}

unit DFWAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DFWButtonComps, StdCtrls, ShellApi;

type
  TDFWAboutForm = class(TForm)
    Image1: TImage;
    DFWSquareButton1: TDFWSquareButton;
    Label1: TLabel;
    ComponentNameLabel: TLabel;
    Label3: TLabel;
    AuthorLabel: TLabel;
    Label5: TLabel;
    EMailLabel: TLabel;
    Label7: TLabel;
    HomepageLabel: TLabel;
    Label9: TLabel;
    VersionLabel: TLabel;
    Bevel1: TBevel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    procedure EMailLabelClick(Sender: TObject);
    procedure HomepageLabelClick(Sender: TObject);
    procedure DFWSquareButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure OpenObject(sObjectPath : string);
  end;

procedure ShowDFWAboutDialog(ComponentName, Version, Author, EMail, Homepage: string);
implementation

{$R *.DFM}
procedure TDFWAboutForm.OpenObject(sObjectPath : String);
begin
 ShellExecute(0, Nil, PChar(sObjectPath), Nil, Nil, SW_NORMAL);
end;


procedure TDFWAboutForm.EMailLabelClick(Sender: TObject);
begin
     OpenObject('mailto:'+TLabel(Sender).Caption);
end;

procedure TDFWAboutForm.HomepageLabelClick(Sender: TObject);
begin
  OpenObject(TLabel(Sender).Caption);
end;

procedure TDFWAboutForm.DFWSquareButton1Click(Sender: TObject);
begin
  ModalResult:=mrok;
end;

procedure ShowDFWAboutDialog(ComponentName, Version, Author, EMail, Homepage: string);
var
  DFWAboutForm: TDFWAboutForm;
begin
     DFWAboutForm:=TDFWAboutForm.create(application);
     with DFWAboutForm do begin
       ComponentNameLabel.caption:=ComponentName;
       VersionLabel.caption:=Version;
       AuthorLabel.caption:=Author;
       EMailLabel.caption:=EMail;
       HomePageLabel.caption:=Homepage;
       ShowModal;
       Free;
     end;
end;

procedure TDFWAboutForm.FormCreate(Sender: TObject);
begin
{$IFNDEF D2}
     EMailLabel.Cursor:=crHandPoint;
     HomepageLabel.Cursor:=EMailLabel.Cursor;
     Label12.Cursor:=EMailLabel.Cursor;
     Label15.Cursor:=EMailLabel.Cursor;
{$ENDIF}
end;

end.
