{******************************************************************************}
{          This unit is part of the Delphifreeware component package.          }
{                                                                              }
{ Filename           : DFWPhantom.pas                                          }
{ Short description  :                                                         }
{ Author             : Roland Gruber                                           }
{ E-Mail             : gruberroland@netscape.net                               }
{ Internet           :                                                         }
{ Version            : 5.0                                                     }
{ Date last modified :                                                         }
{ Delphi versions    :                                                         }
{                                                                              }
{                                                                              }
{ Add. Copyright     :                                                         }
{                                                                              }
{ Description        : Visible: defines if your form is visible or not         }
{                      Serviceprocess: hides the program from Strg+Alt+Entf    }
{                                      and makes sure that it is continued     }
{                                      even the user loggs of and loggs in     }
{                                      under a different name                  }
{                     Iconfile: filename of the .ico-file for the taskbar icon }
{                     Iconvisibility: defines if the taskbar icon is visible   }
{                     Popupright: name of the popup window that appears when   }
{                                 the user right clicks on the taskbar icon    }
{                     Popupleft:  the same as above on left click              }
{                     Leftclick:  what happens if the user left clicks on      }
{                                 the taskbar icon                             }
{                     Rightclick: same as above on a right click               }
{                     Doubleclick: same as above on a double click             }
{                     Tip: Text that is shown when cursor is over taskbar icon }
{                     Flash: flashes the button in the taskbar                 }
{                            (!!! returns to false immediately after being set }
{                                 to true (one flashing)!!!)                   }
{                     FlashTime: time(ms) of flashing                          }
{                     Priority: Priority of the application                    }
{                     MousePosX: Position of cursor on x-axis                  }
{                     MousePosY: Position of cursor on y-axis                  }
{                     MouseRightClick: simulates click of the right mouse button}
{                     MouseLeftClick: simulates click of the left mouse button }
{                     MouseMiddleClick: simulates click of the middle mouse button}
{                                                                              }
{                                                                              }
{ Usage              : PAY ATTENTION!!! This component does not work with      }
{                      Win NT!                                                 }
{                                                                              }
{ Revision history   :                                                         }
{                                                                              }
{ This unit contains the following                                             }
{ Components       : TDFWPhantom                                               }
{ Classes          :                                                           }
{ Types            : TPriotity                                                 }
{ Constants        : TASKBAREVENT                                              }
{ Global variables :                                                           }
{ Global procedures:                                                           }
{ Global functions :                                                           }
{                                                                              }
{******************************************************************************}
{                                                                              }
{  DFW and Delphifreeware   2000, Carsten Butzek E-Mail: cabutzek@muenster.de }
{                                                                              }
{  Delphifreeware or DFW is a free Delphi component collection.                }
{  If you wrote a component which should be integrated into the DFW please     }
{  contact me.                                                                 }
{                                                                              }
{  Updates of the DFW package are available at the DFW homepage:               }
{  http://www.delphifreeware.de                                                }
{                                                                              }
{******************************************************************************}
{ License agreement                                                            }
{                                                                              }
{  This unit is freeware.                                                      }
{                                                                              }
{  Please do not release modified versions of this source code.                }
{  If you've made any changes that you think should have been there,           }
{  feel free to submit them to me at cabutzek@muenster.de                      }
{                                                                              }
{                                                                              }
{  This software is provided 'as-is', without any express or                   }
{  implied warranty. In no event will the author be held                       }
{  liable for any damages arising from the use of this                         }
{  software.                                                                   }
{  Permission is granted to anyone to use this software for                    }
{  any purpose, including commercial applications, and to                      }
{  alter it and redistribute it freely, subject to the                         }
{  following restrictions:                                                     }
{  1. The origin of this software must not be misrepresented,                  }
{     you must not claim that you wrote the original software.                 }
{     If you use this software in a product, an acknowledgment                 }
{     in the product documentation would be appreciated but is                 }
{     not required.                                                            }
{  2. Altered source versions must be plainly marked as such,                  }
{     and must not be misrepresented as being the original                     }
{     software.                                                                }
{  3. This notice may not be removed or altered from any                       }
{     source distribution.                                                     }
{  4. You must credit the DFW team in  your software including a               }
{     link to the DFW homepage at http://www.delphifreeware.de.                }
{                                                                              }
{ End of license agreement                                                     }
{                                                                              }
{******************************************************************************}

{$I DFW.INC}

unit DFWPhantom;

interface

uses
  Windows, wintypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, menus, shellapi, extctrls;

const
  TASKBAREVENT: PChar = 'NewTNIMessage_20';

  ComponentVersion='5.0';
  ComponentAuthor='Roland Gruber';
  ComponentEMail='gruberroland@netscape.net';
  ComponentHomePage='';

type

  TPriotity = (Idle, Normal, High, Realtime);
  TDFWPhantom = class(TComponent)
  private
    fIconDatei: Ticon;
    ftip:string  ;
    fSichtbar: Boolean ;
    fServiceprocess: Boolean ;
    fLinksKlick: TNotifyEvent;
    fRechtsKlick: TNotifyEvent;
    fDoppelKlick: TNotifyEvent;
    fIconSichtbarkeit: boolean;
    fPopupRechts: TPopupMenu;
    fPopupLinks: TPopupMenu;
    fblinken:boolean;
    fblinkdauer:integer;
    fprioritaet: TPriotity;
    fcursor: TPoint;
    { Private-Deklarationen }
    function GetVersion:string;
    function GetAuthor:string;
    function GetEMail:string;
    function GetHomepage:string;
    procedure PWsichtbarkeit(value:boolean);
    procedure PWserviceprocess(value:boolean);
    procedure sichtbarmachen;
    procedure unsichtbarmachen;
    procedure WPopRechts;
    procedure WPopLinks;
    procedure CreateIcon;
    procedure ChangeIcon;
    procedure DeleteIcon;
    procedure settip(value:string);
    procedure Wicondatei(value:Ticon);
    procedure WIconSichtbarkeit(value:boolean);
    procedure blink(value:boolean);
    procedure prioritaetsetzen(value:TPriotity);
    function  getposx:integer;
    function  getposy:integer;
    procedure setposx(value:integer);
    procedure setposy(value:integer);
  protected
    { Protected-Deklarationen }
    procedure serviceprocessEin;
    procedure serviceprocessAus;
    procedure WRechtsklick; virtual;
    procedure WLinksklick; virtual;
    procedure WDoppelklick; virtual;
    procedure WndProc(var Msg: TMessage);
    procedure Notification(Component: TComponent; Operation: TOperation); override;
  public
    { Public-Deklarationen }
      procedure loaded;override;
      destructor Destroy; override;
      constructor Create(AOwner: TComponent); override;
   published
    { Published-Deklarationen }
    procedure MouseRightClick;
    procedure MouseLeftClick;
    procedure MouseMiddleClick;
    property Visible: Boolean read fsichtbar write PWsichtbarkeit;{Formular verstecken/anzeigen}
    property Serviceprocess: Boolean read fserviceprocess write PWserviceprocess;{Als Service-Process registrieren/abmelden (gegen Strg+Alt+Entf)}
    property Iconfile: Ticon read fIconDatei write Wicondatei;
    property Iconvisibility: boolean read fIconSichtbarkeit write WIconSichtbarkeit;
    property Leftclick: TNotifyEvent read fLinksKlick write flinksklick;
    property Rightclick: TNotifyEvent read fRechtsKlick write fRechtsklick;
    property Doublelick: TNotifyEvent read fDoppelKlick write fDoppelklick;
    property PopupRight: TPopupMenu read fPopupRechts write fPopuprechts;
    property PopupLeft: TPopupMenu read fPopupLinks write fPopuplinks;
    property Tip: string read FTip write SetTip;
    property Flash: boolean read fblinken write blink;
    property FlashTime: integer read fblinkdauer write fblinkdauer;
    property Priority: TPriotity  read fprioritaet write prioritaetsetzen;
    property MousePosX: integer read getposx write setposx;
    property MousePosY: integer read getposy write setposy;
    property Version: string read GetVersion;
    property Author: string read GetAuthor;
    property EMail: string read GetEMail;
    property Homepage: string read GetHomepage;
  end;

function RegisterServiceProcess(dwProcessId,dwType:dword): Integer;stdcall;external 'kernel32.dll'

implementation

var ficonmessage: UINT;
    FWnd: HWnd;

constructor TDFWPhantom.Create(AOwner: TComponent) ;
begin
  inherited Create(AOwner);
  ficonmessage := RegisterWindowMessage(TASKBAREVENT);
  FWnd := AllocateHWnd(WndProc);
  FIcondatei := TIcon.Create;
  iconvisibility:=false ;
  visible:=true;
  serviceprocess:=false;
  fblinken:=false;
  fblinkdauer:=300;
  priority:=normal;
end;

destructor TDFWPhantom.Destroy;
begin
  if Ficonsichtbarkeit then deleteIcon;
  FIcondatei.Free;
  DeallocateHWnd(FWnd);
  inherited destroy;
end;

procedure TDFWPhantom.WndProc(var Msg: TMessage);
begin
  with Msg do begin
    if Msg = ficonmessage then
      case LParamLo of
        WM_LBUTTONDOWN:   WLinksKlick;
        WM_RBUTTONDOWN:   WRechtsKlick;
        WM_LBUTTONDBLCLK: WDoppelKlick;
      end
    else
      Result := DefWindowProc(FWnd, Msg, wParam, lParam);
  end;
end;

procedure TDFWPhantom.Notification(Component: TComponent; Operation: TOperation);
begin
  inherited Notification(Component, Operation);
  if Operation = opRemove then begin
    if Component = FPopuprechts then FPopuprechts := nil;
    if Component = FPopuplinks then FPopuplinks := nil;
  end;
end;

procedure TDFWPhantom.PWsichtbarkeit(value:boolean);
begin
  fsichtbar:=value;
  if (csDesigning in ComponentState) then exit;
  if visible=true then sichtbarmachen;
  if visible=false then unsichtbarmachen;
end;

procedure TDFWPhantom.PWserviceprocess(value:boolean);
begin
  fserviceprocess:=value;
  if serviceprocess then serviceprocessEin;
  if not serviceprocess then serviceprocessAus;
end;

procedure TDFWPhantom.serviceprocessEin;
begin
  if (csDesigning in ComponentState) then exit;
  RegisterServiceProcess(GetCurrentProcessID,1)
end;

procedure TDFWPhantom.serviceprocessAus;
begin
  if (csDesigning in ComponentState) then exit;
  RegisterServiceProcess(GetCurrentProcessID,0)
end;

procedure TDFWPhantom.sichtbarmachen;
begin
  if (csDesigning in ComponentState) then exit;
  showwindow(FindWindow(nil, @Application.Title[1]),SW_RESTORE)
end;

procedure TDFWPhantom.unsichtbarmachen;
var handle:HWND;
begin
  if (csDesigning in ComponentState) then exit;
  handle:=FindWindow(nil, @Application.Title[1]);
  showwindow(handle,SW_MINIMIZE);
  showwindow(handle,SW_HIDE) ;
end;

procedure TDFWPhantom.WRechtsklick;
begin
  if Assigned(FPopuprechts) then WPoprechts
    else if Assigned(FRechtsKlick) then
      FRechtsKlick(Self);
end;

procedure TDFWPhantom.WLinksklick;
begin
  if Assigned(FPopuplinks) then WPoplinks
    else if Assigned(FLinksKlick) then
      FLinksKlick(Self);
end;

procedure TDFWPhantom.WDoppelklick;
begin
  if Assigned(Fdoppelklick)then FDoppelKlick(Self);
end;

procedure TDFWPhantom.WPopRechts;
var punkt:Tpoint;
begin
  GetCursorPos(Punkt);
  SetForeGroundWindow(FWnd);
  FPopuprechts.Popup(Punkt.X, Punkt.Y);
end;

procedure TDFWPhantom.WPopLinks;
var punkt:Tpoint;
begin
  GetCursorPos(Punkt);
  SetForeGroundWindow(FWnd);
  FPopuplinks.Popup(Punkt.X, Punkt.Y);
end;

procedure TDFWPhantom.CreateIcon;
var icon: TNOTIFYICONDATA;
begin
with icon do begin
    cbSize := SizeOf(TNOTIFYICONDATA);
    Wnd := FWnd;
    uID := 1;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    uCallbackMessage :=ficonMessage;
    hIcon := FIcondatei.Handle;
    StrCopy(szTip, PChar(FTip));
    Shell_NotifyIcon(NIM_ADD, @icon);
  end;
ficonsichtbarkeit:=true;
end;

procedure TDFWPhantom.ChangeIcon;
var icon: TNOTIFYICONDATA;
begin
with icon do begin
    cbSize := SizeOf(TNOTIFYICONDATA);
    Wnd := FWnd;
    uID := 1;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    uCallbackMessage := ficonMessage;
    hIcon := FIcondatei.Handle;
    StrCopy(szTip, PChar(FTip));
    Shell_NotifyIcon(NIM_MODIFY, @icon);
  end;
ficonsichtbarkeit:=true;
end;

procedure TDFWPhantom.DeleteIcon;
var icon: TNOTIFYICONDATA;
begin
with icon do begin
    cbSize := SizeOf(TNOTIFYICONDATA);
    Wnd := FWnd;
    uID := 1;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
    uCallbackMessage := ficonmessage;
    hIcon := FIcondatei.Handle;
    StrCopy(szTip, PChar(FTip));
    Shell_NotifyIcon(NIM_DELETE, @icon);
  end;
ficonsichtbarkeit:=false;
end;

procedure TDFWPhantom.settip(value:string);
begin
if FTip <> value then begin
    FTip := value;
    changeicon;
  end;
end;

procedure TDFWPhantom.Wicondatei(value:Ticon);
begin
if ficondatei<>value then begin
      ficondatei.assign(value);
      if (csDesigning in ComponentState) then exit;
      if ficonsichtbarkeit then changeicon else createicon;
      if ficondatei.empty then deleteicon;
  end;
end;

procedure TDFWPhantom.WIconSichtbarkeit(value:boolean);
begin
ficonsichtbarkeit:=value;
if not (csDesigning in ComponentState) then begin
   if ficonsichtbarkeit then createicon;
   if not ficonsichtbarkeit then deleteicon;
   end;
end;

procedure TDFWPhantom.Loaded;
begin
  inherited Loaded;
  if Ficonsichtbarkeit and not FIcondatei.Empty then begin
    createIcon;
  end;
end;

procedure TDFWPhantom.blink(value:boolean);
begin
  fblinken:=value;
  if fblinken=false then exit;
  flashwindow(application.handle,true);
  sleep(fblinkdauer);
  flashwindow(application.handle,true);
  fblinken:=false;
end;

procedure TDFWPhantom.prioritaetsetzen(value:TPriotity);
begin
  fprioritaet:=value;
  if (csdesigning in componentstate) then exit;
  case value of 
       Idle : setpriorityclass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
        Normal : setpriorityclass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
        High : setpriorityclass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
        Realtime : setpriorityclass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
  end;
end;

procedure TDFWPhantom.MouseRightClick;
begin
mouse_event(MOUSEEVENTF_RIGHTDOWN,0,0,0,0);
mouse_event(MOUSEEVENTF_RIGHTUP,0,0,0,0);
end;

procedure TDFWPhantom.MouseLeftClick;
begin
mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
end;

procedure TDFWPhantom.MouseMiddleClick;
begin
mouse_event(MOUSEEVENTF_MIDDLEDOWN,0,0,0,0);
mouse_event(MOUSEEVENTF_MIDDLEUP,0,0,0,0);
end;

procedure TDFWPhantom.setposx(value:integer);
begin
getcursorpos(fcursor);
fcursor.x:=value;
setcursorpos(fcursor.x, fcursor.y);
end;

procedure TDFWPhantom.setposy(value:integer);
begin
getcursorpos(fcursor);
fcursor.y:=value;
setcursorpos(fcursor.x, fcursor.y);
end;

function TDFWPhantom.getposx:integer;
begin
getcursorpos(fcursor);
result:=fcursor.x;
end;

function TDFWPhantom.getposy:integer;
begin
getcursorpos(fcursor);
result:=fcursor.y;
end;

function TDFWPhantom.GetVersion:string;
begin
     Result:=ComponentVersion;
end;

function TDFWPhantom.GetAuthor:string;
begin
     Result:=ComponentAuthor;
end;

function TDFWPhantom.GetEMail:string;
begin
     Result:=ComponentEMail;
end;

function TDFWPhantom.GetHomepage:string;
begin
     Result:=ComponentHomePage;
end;

end.
